#!/usr/bin/env bash

# The directory of this script is also the project's root directory.
ROOT="$( cd "$( dirname "${BASH_SOURCE[0]}" )" &> /dev/null && pwd )"

IMAGE=$(sed --regexp-extended --quiet 's;^image: "([^"]*)"$;\1;p' "${ROOT}/.gitlab-ci.yml")

docker run \
	   --volume="${ROOT}:${ROOT}" \
	   --interactive \
	   --tty \
	   --security-opt=seccomp:unconfined \
	   --env USER_ID="${UID}" \
	   --env GROUP_ID="$(id -g ${USER})" \
	   "${IMAGE}" \
	   "${ROOT}/tools/docker-prepare" "${ROOT}" $@
