#!/bin/bash

set -euo pipefail

SUM=./summarize.py
PLOT=./gen_boxplots.py

PLOT_DIR=plots/
PLOT_PREFIX=iol

RESULTS=$1
shift

if [[ -z "${RESULTS}" ]]; then
	echo "Usage: $0 path/to/results"
	exit 1
fi

${SUM} --yaml -i emper-pipe emper-pipe-no-hint -- "${RESULTS}" \
	| BOXPLOT="hints" ${PLOT} > ${PLOT_DIR}/${PLOT_PREFIX}-hints.tex

${SUM} --yaml -i emper-pipe emper-pipe-no-comp emper-io-stealing-pipe-no-comp -- "${RESULTS}" \
	| BOXPLOT="latency" ${PLOT} > ${PLOT_DIR}/${PLOT_PREFIX}-latency.tex

${SUM} --yaml -i emper-vanilla emper-no-sleep -- "${RESULTS}" \
    | BOXPLOT="contention" ${PLOT} > ${PLOT_DIR}/${PLOT_PREFIX}-contention.tex

${SUM} --yaml -i emper-vanilla emper-greedy-sem -- "${RESULTS}" \
    | BOXPLOT="greedy-sem" ${PLOT} > ${PLOT_DIR}/${PLOT_PREFIX}-greedy-sem.tex

${SUM} --yaml -i emper-vanilla emper-pipe emper-waitfd -- "${RESULTS}" \
	| BOXPLOT="strategies" ${PLOT} > ${PLOT_DIR}/${PLOT_PREFIX}-strategies.tex

${SUM} --yaml -i emper-io-notification-waitfd-no-comp emper-io-notification-waitfd \
                 emper-io-stealing-waitfd-no-comp emper-io-stealing-waitfd -- "${RESULTS}" \
    | BOXPLOT="n-s-c" ${PLOT} > ${PLOT_DIR}/${PLOT_PREFIX}-notification-stealing-completer.tex

${SUM} --yaml -i emper-io-notification-lockless-waitfd-no-comp emper-io-notification-waitfd-no-comp \
                 emper-io-stealing-lockless-waitfd-no-comp emper-io-stealing-waitfd-no-comp -- "${RESULTS}" \
    | BOXPLOT="l-vs-ll" ${PLOT} > ${PLOT_DIR}/${PLOT_PREFIX}-lockless-vs-locked.tex

${SUM} --yaml -i emper-io-notification-waitfd-no-comp \
                 emper-stealing-no-sleep emper-stealing-lockless-no-sleep -- "${RESULTS}" \
    | BOXPLOT="n-vs-ns" ${PLOT} > ${PLOT_DIR}/${PLOT_PREFIX}-notification-vs-nosleep.tex


